//+------------------------------------------------------------------+
//|                                                    Mahim.mq4 |
//|                           |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#include <stdlib.mqh>      //library for managing errors between different
#include <WinUser32.mqh>   //library to use the dialogs

extern double lot = 0.1;      // lot of the order
extern double take_profit= 50; //pips

int magic = 666;
bool pos;
int stop;
int cntp, cntg;
string sym;
int ordre;
int spread;
double prixA, prixV;
double eqA, eqV, eqAF, eqVF;
int ticketA, ticketV, ticketF;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   sym = Symbol();
   stop = 0;
   pos= false;             // dual position open or not
   cntg = 0;               // position number Won
   cntp = 0;               // number of lost position
   ordre = 0;              // number of orders remaining
   spread = MarketInfo (sym, MODE_SPREAD);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete ("eqA = ");
   ObjectDelete ("eqV = ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if (stop == 1) {
      Print ("L\'EA is disabled...");
      return (0);
   }
   int retour, error;
   if (pos == false) {
      Print ("first tick");
      debug ();
      retour = OrderSend (sym, OP_BUY, lot, Ask, 3, 0, Bid + take_profit * Point, "buy!!!", magic, 0, Blue);
      if (retour < 1) {
            error = GetLastError();
            Print ("error d\'order d\'purchase: (",error,"): ", ErrorDescription(error));
            return (0);
      }
      OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES);
      ticketA = OrderTicket ();
      prixA = OrderOpenPrice ();
      eqA = NormalizeDouble (Bid + Point, Digits);
      eqAF = NormalizeDouble (Bid + (take_profit * Point), Digits);
      ordre++;
      affichage ("eqA = ", eqA, Blue);
      retour = OrderSend (sym, OP_SELL, lot, Bid, 3, 0, Ask - take_profit * Point, "sell !!!", magic, 0, Red);
      if (retour < 1) {
            error = GetLastError();
            Print ("error d\'sell: (",error,"): ", ErrorDescription(error));
            return (0);
      }
      OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES);
      ticketV = OrderTicket ();
      prixV = OrderOpenPrice ();
      eqV = NormalizeDouble (Ask - Point, Digits);
      eqVF = NormalizeDouble (Bid - (take_profit* Point), Digits);
      ordre++;
      affichage ("eqV = ", eqV, Red);
      pos = true;         
   }
   if (pos == true)  {
      if (Bid == eqA)   {
         Print ("I farm because sales order has lost its spread");
         fermer (ticketV);
         verif ();
         return (0);
      }
      if (Bid == eqV)   {
         Print ("I farm because order  spread has lost its purchase");
         fermer (ticketA);
         verif ();
         return (0);
      }
      if (ordre == 2)   {
         Print ("price spreads between");
         return (0);
      }
      //===> ordre = 1 <=> remaining position monitor
      if (ticketF == ticketA) {              // if order is still selling (short)
         if (Ask <= eqVF)   {   //gain if two spread
            Print ("I farm because gain on sales order");
            fermer (ticketV);
            verif ();
            return (0);            
         }
         if (Ask == eqV)   {   // if loss of two spread
            Print ("I farm because of loss as sales order");
            fermer (ticketV);
            verif ();
            return (0);            
         }
         return (0);
      }  else if (ticketF == ticketV)  {     // if a purchase order is remaining (long)
         if (Bid >= eqAF)   {   // gain if two spread
            Print ("I farm because gain on the order of purchase");
            fermer (ticketA);
            verif ();
            return (0);            
         }
         if (Bid == eqA)   {   // si perte de deux spread
            Print ("I farm because loss also order purchase");
            fermer (ticketA);
            verif ();
            return (0);            
         }
         return (0);
      }
      Print ("Program error, this line could not be executed !");
      debug ();
      
   }
      
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| closing function Order                                 |
//+------------------------------------------------------------------+  
int fermer (int ticket)   {
   int error, retour;
   double prix;
   if (ticket == ticketA)  {
      prix = NormalizeDouble (Bid + (take_profit * Point), Digits);
   }  else if (ticket == ticketV)   {
      prix = NormalizeDouble (Bid - (take_profit* Point), Digits);
   }
   retour = OrderClose(ticket,lot,prix,3,Orange);
   if (retour < 1) {
      error = GetLastError();
      Alert ("misclosure \ 's order:(",error,"): ", ErrorDescription(error)," sur ", ticket);
      Print ("Ask = ", Ask, " et Bid = ", Bid, " et prix = ", prix);
      debug ();
      return (0);
   }
   ordre--;
   OrderSelect(ticket, SELECT_BY_TICKET);
   OrderPrint();
   if (OrderProfit() <= 0)  {
      cntp++;
   }  else{
      cntg++;
   }
   ticketF = OrderTicket ();
   Print ("ticket = ", ticket);
   debug ();
   return (ticketF);

}

//+------------------------------------------------------------------+
//| audit function gains / losses                    |
//+------------------------------------------------------------------+
void verif  () {
   int icon;
   string mess;
   //MB_ICONSTOP, MB_ICONQUESTION, MB_ICONWARNING, MB_ICONASTERISK
   if (cntp + cntg >= 5)   {
      if (cntp == cntg) {
         mess = "Many gains as losses continue?";
         icon = 32;
      }  else if (cntp >= cntg) {
         mess = "More losses than gains, continue?";
         icon = 48;
      }  else if (cntp >= cntg + 7) {
         mess = "Too many losses, do you really want to continue?";
         icon = 16;
      }  else if (cntp < cntg)   {
         mess = "Gains come, keep course?";
         icon = 64;
      }
      int button = MessageBox (mess, "Summary of gains / losses",  MB_YESNO|icon|MB_TOPMOST);
      if (button == IDYES) {
         pos = 0;
         ordre = 0;
         return (0);
      }  else if (button == IDNO)   {
         stop =1;
         return (0);
      }
   }
   pos = 0;
   ordre = 0;
   return (0);

}
//+------------------------------------------------------------------+
//| debugging function                                           |
//+------------------------------------------------------------------+
void debug ()  {
    Print ("stop = ", stop, " pos = ", pos, " ordre = ", ordre);
    Print ("ticketA = ", ticketA, " tivketV = ", ticketV, " ticketF = ", ticketF);
    Print ("eqA= ", eqA, " eqAF = ", eqAF);
    Print ("eqV= ", eqV, " eqVF = ", eqVF);
} 

//+------------------------------------------------------------------+
//| display function                                             |
//+------------------------------------------------------------------+
void affichage (string nom, double niveau, color couleur)   {
   ObjectDelete (nom);
   ObjectCreate (nom, OBJ_HLINE, 0, 0, niveau, 0, 0, 0, 0);
   ObjectSet (nom, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet (nom, OBJPROP_COLOR, couleur);
   return (0);
}

  
//+------------------------------------------------------------------+